
_HEXcharToValue:

;Hex_string_to_byte.mbas,10 :: 		sub function HEXcharToValue(dim character as char) as byte            'function for converting single char to its value, it is probably as efficient as possible, can be used to build
;Hex_string_to_byte.mbas,13 :: 		if (character > 47) AND (character < 58) then
	LDI        R16, 47
	CP         R16, R2
	LDI        R17, 0
	BRSH       L__HEXcharToValue14
	LDI        R17, 255
L__HEXcharToValue14:
	LDI        R27, 58
	CP         R2, R27
	LDI        R16, 0
	BRSH       L__HEXcharToValue15
	LDI        R16, 255
L__HEXcharToValue15:
	AND        R16, R17
	BRNE       L__HEXcharToValue16
	JMP        L__HEXcharToValue2
L__HEXcharToValue16:
;Hex_string_to_byte.mbas,14 :: 		result = character - 48
	MOV        R16, R2
	SUBI       R16, 48
; Result start address is: 17 (R17)
	MOV        R17, R16
; Result end address is: 17 (R17)
	JMP        L__HEXcharToValue3
;Hex_string_to_byte.mbas,15 :: 		else
L__HEXcharToValue2:
;Hex_string_to_byte.mbas,16 :: 		if (character > 64) AND (character < 71)  then
	LDI        R16, 64
	CP         R16, R2
	LDI        R17, 0
	BRSH       L__HEXcharToValue17
	LDI        R17, 255
L__HEXcharToValue17:
	LDI        R27, 71
	CP         R2, R27
	LDI        R16, 0
	BRSH       L__HEXcharToValue18
	LDI        R16, 255
L__HEXcharToValue18:
	AND        R16, R17
	BRNE       L__HEXcharToValue19
	JMP        L__HEXcharToValue5
L__HEXcharToValue19:
;Hex_string_to_byte.mbas,17 :: 		result = character - 65 + 10
	MOV        R16, R2
	SUBI       R16, 65
	SUBI       R16, 246
; Result start address is: 16 (R16)
	MOV        R17, R16
; Result end address is: 16 (R16)
	JMP        L__HEXcharToValue6
;Hex_string_to_byte.mbas,18 :: 		else
L__HEXcharToValue5:
;Hex_string_to_byte.mbas,19 :: 		if (character > 96) AND (character < 103) then
	LDI        R16, 96
	CP         R16, R2
	LDI        R17, 0
	BRSH       L__HEXcharToValue20
	LDI        R17, 255
L__HEXcharToValue20:
	LDI        R27, 103
	CP         R2, R27
	LDI        R16, 0
	BRSH       L__HEXcharToValue21
	LDI        R16, 255
L__HEXcharToValue21:
	AND        R16, R17
	BRNE       L__HEXcharToValue22
	JMP        L__HEXcharToValue8
L__HEXcharToValue22:
;Hex_string_to_byte.mbas,20 :: 		result = character - 97 + 10
	MOV        R16, R2
	SUBI       R16, 97
	SUBI       R16, 246
; Result start address is: 16 (R16)
; Result end address is: 16 (R16)
	JMP        L__HEXcharToValue9
;Hex_string_to_byte.mbas,21 :: 		else
L__HEXcharToValue8:
;Hex_string_to_byte.mbas,22 :: 		result = 0
; Result start address is: 16 (R16)
	LDI        R16, 0
; Result end address is: 16 (R16)
;Hex_string_to_byte.mbas,23 :: 		end if
L__HEXcharToValue9:
;Hex_string_to_byte.mbas,24 :: 		end if
; Result start address is: 16 (R16)
	MOV        R17, R16
; Result end address is: 16 (R16)
L__HEXcharToValue6:
;Hex_string_to_byte.mbas,25 :: 		end if
; Result start address is: 17 (R17)
; Result end address is: 17 (R17)
L__HEXcharToValue3:
;Hex_string_to_byte.mbas,27 :: 		end sub
; Result start address is: 17 (R17)
	MOV        R16, R17
; Result end address is: 17 (R17)
L_end_HEXcharToValue:
	RET
; end of _HEXcharToValue

_HEXstringToByte:
	PUSH       R28
	PUSH       R29
	IN         R28, SPL+0
	IN         R29, SPL+1
	SBIW       R28, 1
	OUT        SPL+0, R28
	OUT        SPL+1, R29
	ADIW       R28, 1

;Hex_string_to_byte.mbas,29 :: 		sub function HEXstringToByte(dim byref hex_string as string[2]) as byte
;Hex_string_to_byte.mbas,31 :: 		result = HEXcharToValue(hex_string[0]) * 16 + HEXcharToValue(hex_string[1])
	PUSH       R2
	PUSH       R3
	MOVW       R30, R2
	LD         R16, Z
	PUSH       R3
	PUSH       R2
	MOV        R2, R16
	CALL       _HEXcharToValue+0
	POP        R2
	POP        R3
	LSL        R16
	LSL        R16
	LSL        R16
	LSL        R16
	STD        Y+0, R16
	MOVW       R30, R2
	ADIW       R30, 1
	LD         R16, Z
	MOV        R2, R16
	CALL       _HEXcharToValue+0
	LDD        R17, Y+0
	ADD        R16, R17
; Result start address is: 17 (R17)
	MOV        R17, R16
;Hex_string_to_byte.mbas,33 :: 		end sub
	MOV        R16, R17
; Result end address is: 17 (R17)
L_end_HEXstringToByte:
	POP        R3
	POP        R2
	OUT        SPL+0, R28
	OUT        SPL+1, R29
	POP        R29
	POP        R28
	RET
; end of _HEXstringToByte

_HEXstringToWord:
	PUSH       R28
	PUSH       R29
	IN         R28, SPL+0
	IN         R29, SPL+1
	SBIW       R28, 2
	OUT        SPL+0, R28
	OUT        SPL+1, R29
	ADIW       R28, 1

;Hex_string_to_byte.mbas,35 :: 		sub function HEXstringToWord(dim byref hex_string as string[4]) as word
;Hex_string_to_byte.mbas,37 :: 		result = HEXcharToValue(hex_string[0]) * 4096 + HEXcharToValue(hex_string[1]) * 256 + HEXcharToValue(hex_string[2]) * 16 + HEXcharToValue(hex_string[3])
	PUSH       R2
	PUSH       R3
	MOVW       R30, R2
	LD         R16, Z
	PUSH       R3
	PUSH       R2
	MOV        R2, R16
	CALL       _HEXcharToValue+0
	POP        R2
	POP        R3
	LDI        R27, 12
	LDI        R17, 0
L__HEXstringToWord25:
	LSL        R16
	ROL        R17
	DEC        R27
	BRNE       L__HEXstringToWord25
L__HEXstringToWord26:
	STD        Y+0, R16
	STD        Y+1, R17
	MOVW       R30, R2
	ADIW       R30, 1
	LD         R16, Z
	PUSH       R3
	PUSH       R2
	MOV        R2, R16
	CALL       _HEXcharToValue+0
	POP        R2
	POP        R3
	MOV        R19, R16
	CLR        R18
	LDD        R16, Y+0
	LDD        R17, Y+1
	ADD        R16, R18
	ADC        R17, R19
	STD        Y+0, R16
	STD        Y+1, R17
	MOVW       R30, R2
	ADIW       R30, 2
	LD         R16, Z
	PUSH       R3
	PUSH       R2
	MOV        R2, R16
	CALL       _HEXcharToValue+0
	POP        R2
	POP        R3
	MOV        R18, R16
	LDI        R19, 0
	LSL        R18
	ROL        R19
	LSL        R18
	ROL        R19
	LSL        R18
	ROL        R19
	LSL        R18
	ROL        R19
	LDD        R16, Y+0
	LDD        R17, Y+1
	ADD        R16, R18
	ADC        R17, R19
	STD        Y+0, R16
	STD        Y+1, R17
	MOVW       R30, R2
	ADIW       R30, 3
	LD         R16, Z
	MOV        R2, R16
	CALL       _HEXcharToValue+0
	LDD        R18, Y+0
	LDD        R19, Y+1
	LDI        R17, 0
	ADD        R16, R18
	ADC        R17, R19
; Result start address is: 18 (R18)
	MOVW       R18, R16
;Hex_string_to_byte.mbas,39 :: 		end sub
	MOVW       R16, R18
; Result end address is: 18 (R18)
L_end_HEXstringToWord:
	POP        R3
	POP        R2
	ADIW       R28, 1
	OUT        SPL+0, R28
	OUT        SPL+1, R29
	POP        R29
	POP        R28
	RET
; end of _HEXstringToWord

_HEXstringToLongWord:
	PUSH       R28
	PUSH       R29
	IN         R28, SPL+0
	IN         R29, SPL+1
	SBIW       R28, 10
	OUT        SPL+0, R28
	OUT        SPL+1, R29
	ADIW       R28, 1

;Hex_string_to_byte.mbas,43 :: 		dim low, high as string[4]
;Hex_string_to_byte.mbas,45 :: 		memcpy(@low, @hex_string+4, 4)
	PUSH       R2
	PUSH       R3
	PUSH       R4
	PUSH       R5
	PUSH       R6
	PUSH       R7
	MOVW       R18, R28
	MOVW       R16, R2
	SUBI       R16, 252
	SBCI       R17, 255
	PUSH       R3
	PUSH       R2
	LDI        R27, 4
	MOV        R6, R27
	LDI        R27, 0
	MOV        R7, R27
	MOVW       R4, R16
	MOVW       R2, R18
	CALL       _memcpy+0
	POP        R2
	POP        R3
;Hex_string_to_byte.mbas,46 :: 		memcpy(@high, @hex_string, 4)
	MOVW       R16, R28
	SUBI       R16, 251
	SBCI       R17, 255
	LDI        R27, 4
	MOV        R6, R27
	LDI        R27, 0
	MOV        R7, R27
	MOVW       R4, R2
	MOVW       R2, R16
	CALL       _memcpy+0
;Hex_string_to_byte.mbas,48 :: 		result = HEXstringToWord(high)
	MOVW       R16, R28
	SUBI       R16, 251
	SBCI       R17, 255
	MOVW       R2, R16
	CALL       _HEXstringToWord+0
; Result start address is: 20 (R20)
	MOVW       R20, R16
	LDI        R22, 0
	MOV        R23, R22
;Hex_string_to_byte.mbas,49 :: 		result = result << 16
	MOV        R19, R21
	MOV        R18, R20
	CLR        R16
	CLR        R17
	MOVW       R20, R16
	MOVW       R22, R18
;Hex_string_to_byte.mbas,50 :: 		result = result + HEXstringToWord(low)
	MOVW       R16, R28
	MOVW       R2, R16
	CALL       _HEXstringToWord+0
	LDI        R18, 0
	MOV        R19, R18
	ADD        R16, R20
	ADC        R17, R21
	ADC        R18, R22
	ADC        R19, R23
	MOVW       R20, R16
	MOVW       R22, R18
;Hex_string_to_byte.mbas,51 :: 		end sub
	MOVW       R16, R20
	MOVW       R18, R22
; Result end address is: 20 (R20)
L_end_HEXstringToLongWord:
	POP        R7
	POP        R6
	POP        R5
	POP        R4
	POP        R3
	POP        R2
	ADIW       R28, 9
	OUT        SPL+0, R28
	OUT        SPL+1, R29
	POP        R29
	POP        R28
	RET
; end of _HEXstringToLongWord

_Hex_string_to_byte_?main:

;Hex_string_to_byte.mbas,53 :: 		end.
L_end_Hex_string_to_byte_?main:
	RET
; end of _Hex_string_to_byte_?main
